"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var pick_1 = __importDefault(require("lodash/pick"));
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
require("@feathersjs/transport-commons");
var ability_1 = require("@casl/ability");
var channels_utils_1 = require("./channels.utils");
var getModelName_1 = __importDefault(require("../utils/getModelName"));
var hasRestrictingFields_1 = __importDefault(require("../utils/hasRestrictingFields"));
var base_1 = require("@feathersjs/transport-commons/lib/channels/channel/base");
exports.default = (function (app, data, context, options) {
    options = channels_utils_1.makeOptions(app, options);
    var channelOnError = options.channelOnError, activated = options.activated;
    var modelName = getModelName_1.default(options.modelName, context);
    if (!activated || !modelName) {
        return (!channelOnError) ? new base_1.Channel() : app.channel(channelOnError);
    }
    var channels = app.channels;
    //return app.channel(channels);
    var allConnections = app.channel(channels).connections;
    var dataToTest = ability_1.subject(modelName, data);
    if (!options.restrictFields) {
        // return all fields for allowed 
        var connections = allConnections
            .filter(function (connection) {
            var ability = channels_utils_1.getAbility(app, data, connection, context, options);
            return ability && ability.can("get", dataToTest);
        });
        connections = __spread(new Set(connections));
        return new base_1.Channel(connections, data);
    }
    else {
        // filter by restricted Fields
        var connectionsPerFields = [];
        var _loop_1 = function (i, n) {
            var connection = allConnections[i];
            var ability = connection.ability;
            if (!ability || !ability.can("get", dataToTest)) {
                return "continue";
            }
            var availableFields = (!(options === null || options === void 0 ? void 0 : options.availableFields))
                ? undefined
                : (typeof options.availableFields === "function")
                    ? options.availableFields(context)
                    : options.availableFields;
            var fields = hasRestrictingFields_1.default(ability, "get", dataToTest, { availableFields: availableFields });
            // if fields is true or fields is empty array -> full restriction
            if (fields && (fields === true || fields.length === 0)) {
                return "continue";
            }
            var connField = connectionsPerFields.find(function (x) { return isEqual_1.default(x.fields, fields); });
            if (connField) {
                if (connField.connections.indexOf(connection) !== -1) {
                    return "continue";
                }
                connField.connections.push(connection);
            }
            else {
                connectionsPerFields.push({
                    connections: [connection],
                    fields: fields
                });
            }
        };
        for (var i = 0, n = allConnections.length; i < n; i++) {
            _loop_1(i, n);
        }
        var channels_1 = [];
        for (var i = 0, n = connectionsPerFields.length; i < n; i++) {
            var _a = connectionsPerFields[i], fields = _a.fields, connections = _a.connections;
            var restrictedData = (fields)
                ? pick_1.default(data, fields)
                : data;
            if (!isEmpty_1.default(restrictedData)) {
                channels_1.push(new base_1.Channel(connections, restrictedData));
            }
        }
        return channels_1.length === 1
            ? channels_1[0]
            : channels_1;
    }
});
