"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var feathers_hooks_common_1 = require("feathers-hooks-common");
var ability_1 = require("@casl/ability");
var pick_1 = __importDefault(require("lodash/pick"));
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var hasRestrictingFields_1 = __importDefault(require("../../utils/hasRestrictingFields"));
var feathers_utils_1 = require("feathers-utils");
var authorize_hook_utils_1 = require("./authorize.hook.utils");
var getModelName_1 = __importDefault(require("../../utils/getModelName"));
var errors_1 = require("@feathersjs/errors");
var HOOKNAME = "authorize";
exports.default = (function (options) {
    return function (context) { return __awaiter(void 0, void 0, void 0, function () {
        var $select, modelName, skipCheckConditions, skipCheckFields, params, _a, ability, items, availableFields, hasRestrictingFieldsOptions, pickFieldsForItem, result, i, n, item;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    $select = authorize_hook_utils_1.restore$select(context);
                    if (feathers_utils_1.shouldSkip(HOOKNAME, context) ||
                        context.type !== "after" ||
                        !context.params) {
                        return [2 /*return*/, context];
                    }
                    options = authorize_hook_utils_1.makeOptions(context.app, options);
                    modelName = getModelName_1.default(options.modelName, context);
                    if (!modelName) {
                        return [2 /*return*/, context];
                    }
                    skipCheckConditions = authorize_hook_utils_1.getPersistedConfig(context, "skipRestrictingRead.conditions");
                    skipCheckFields = authorize_hook_utils_1.getPersistedConfig(context, "skipRestrictingRead.fields");
                    if (skipCheckConditions && skipCheckFields) {
                        return [2 /*return*/, context];
                    }
                    params = context.params;
                    _a = params;
                    return [4 /*yield*/, authorize_hook_utils_1.getAbility(context, options)];
                case 1:
                    _a.ability = _b.sent();
                    if (!params.ability) {
                        // Ignore internal or not authenticated requests
                        return [2 /*return*/, context];
                    }
                    ability = params.ability;
                    items = feathers_hooks_common_1.getItems(context);
                    availableFields = (!(options === null || options === void 0 ? void 0 : options.availableFields))
                        ? undefined
                        : (typeof options.availableFields === "function")
                            ? options.availableFields(context)
                            : options.availableFields;
                    hasRestrictingFieldsOptions = {
                        availableFields: availableFields
                    };
                    pickFieldsForItem = function (item) {
                        var method = (Array.isArray(items)) ? "find" : "get";
                        if (!skipCheckConditions && !ability.can(method, ability_1.subject(modelName, item))) {
                            return undefined;
                        }
                        var fields = hasRestrictingFields_1.default(ability, method, ability_1.subject(modelName, item), hasRestrictingFieldsOptions);
                        if (fields === true) {
                            // full restriction
                            return {};
                        }
                        else if (skipCheckFields || (!fields && !$select)) {
                            // no restrictions
                            return item;
                        }
                        else if (fields && $select) {
                            fields = feathers_utils_1.mergeArrays(fields, $select, "intersect");
                        }
                        else {
                            fields = (fields) ? fields : $select;
                        }
                        return pick_1.default(item, fields);
                    };
                    if (Array.isArray(items)) {
                        result = [];
                        for (i = 0, n = items.length; i < n; i++) {
                            item = pickFieldsForItem(items[i]);
                            if (item) {
                                result.push(item);
                            }
                        }
                    }
                    else {
                        result = pickFieldsForItem(items);
                        if (context.method === "get" && isEmpty_1.default(result)) {
                            if (options.actionOnForbidden)
                                options.actionOnForbidden();
                            throw new errors_1.Forbidden("You're not allowed to " + context.method + " " + modelName);
                        }
                    }
                    feathers_hooks_common_1.replaceItems(context, result);
                    return [2 /*return*/, context];
            }
        });
    }); };
});
