"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ability_1 = require("@casl/ability");
var feathers_utils_1 = require("feathers-utils");
var getMinimalFields = function (ability, action, subject, options) {
    var _a;
    if (options.checkCan && !ability.can(action, subject)) {
        return [];
    }
    var subjectType = ability_1.detectSubjectType(subject);
    var rules = ability.possibleRulesFor(action, subjectType).filter(function (rule) {
        var fields = rule.fields;
        var matched = rule.matchesConditions(subject);
        return fields && matched;
    });
    if (rules.length === 0) {
        return options.availableFields || [];
    }
    var fields;
    if (options.availableFields) {
        fields = options.availableFields;
    }
    else {
        fields = (_a = rules.find(function (x) { return !x.inverted; })) === null || _a === void 0 ? void 0 : _a.fields;
        if (!fields) {
            return [];
        }
    }
    rules.forEach(function (rule) {
        if (rule.inverted) {
            fields = fields.filter(function (x) { return !rule.fields.includes(x); });
        }
        else {
            fields = feathers_utils_1.mergeArrays(fields, rule.fields, "intersect");
        }
    });
    return fields;
};
exports.default = getMinimalFields;
