"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var feathers_utils_1 = require("feathers-utils");
var getFieldsQueryFor_1 = __importDefault(require("./getFieldsQueryFor"));
var getConditionalQueryFor_1 = __importDefault(require("./getConditionalQueryFor"));
var getQueryFor = function (ability, method, modelName, options) {
    options = options || {
        availableFields: []
    };
    var skipConditional = options.skipConditional, skipFields = options.skipFields;
    if (skipConditional && skipFields) {
        return {};
    }
    var conditionsQuery = (!skipConditional)
        ? getConditionalQueryFor_1.default(ability, method, modelName, { actionOnForbidden: options.actionOnForbidden })
        : {};
    var fieldsQuery = (!skipFields)
        ? getFieldsQueryFor_1.default(ability, method, modelName, { availableFields: options.availableFields })
        : {};
    var query = feathers_utils_1.mergeQuery(conditionsQuery, fieldsQuery, { defaultHandle: "combine" });
    return query;
};
exports.default = getQueryFor;
