"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var extra_1 = require("@casl/ability/extra");
var getMinimalFields_1 = __importDefault(require("./getMinimalFields"));
function areSameArray(arr1, arr2) {
    if (arr1.length != arr2.length) {
        return false;
    }
    var arr1test = arr1.slice().sort();
    var arr2test = arr2.slice().sort();
    var result = !arr1test.some(function (val, idx) { return val !== arr2test[idx]; });
    return result;
}
var hasRestrictingFields = function (ability, action, subject, options) {
    var fields;
    if (typeof subject !== "string") {
        fields = getMinimalFields_1.default(ability, action, subject, {
            availableFields: options.availableFields,
            checkCan: false
        });
    }
    else {
        var permittedFieldsOfOptions = {
            fieldsFrom: function (rule) {
                return rule.fields || options.availableFields || [];
            }
        };
        fields = extra_1.permittedFieldsOf(ability, action, subject, permittedFieldsOfOptions);
    }
    if (fields.length === 0 && !options.availableFields) {
        return false;
    }
    if (fields.length > 0) {
        // check if fields is restricting at all or just complete array
        if (options.availableFields === fields ||
            (options.availableFields && areSameArray(fields, options.availableFields))) {
            // arrays are the same -> no restrictions
            return false;
        }
        else {
            return fields;
        }
    }
    return true;
};
exports.default = hasRestrictingFields;
